Index: main/plugin-odf-sync/src/org/ametys/plugins/odfsync/cdmfr/AbstractCDMFrManager.java
===================================================================
--- main/plugin-odf-sync/src/org/ametys/plugins/odfsync/cdmfr/AbstractCDMFrManager.java	(revision 41919)
+++ main/plugin-odf-sync/src/org/ametys/plugins/odfsync/cdmfr/AbstractCDMFrManager.java	(working copy)
@@ -297,7 +297,7 @@
             }
             else
             {
-                hasChanges = synchronizeMetadata (doc, content, metadataNode, report, logger, importMode, programLanguage, remoteChildCodes) || hasChanges;
+                hasChanges = synchronizeMetadata (contentNode, doc, content, metadataNode, report, logger, importMode, programLanguage, remoteChildCodes) || hasChanges;
             }
         }
         
@@ -445,6 +445,7 @@
     
     /**
      * Synchronize content metadata
+     * @param contentNode the content node
      * @param doc The root document
      * @param content The content to synchronize
      * @param metadataNode the DOM for metadata
@@ -452,10 +453,11 @@
      * @param logger The logger
      * @param importMode <code>true</code> if it is import mode
      * @param programLanguage Parent program language (to select the good courses in the CDM-FR file)
+     * @param remoteChildCodes 
      * @return <code>true</code> if changes were made
      * @throws WorkflowException
      */
-    protected boolean synchronizeMetadata (Document doc, SynchronizableContent content, Node metadataNode, SynchronizationReport report, Logger logger, boolean importMode, String programLanguage, Set<String> remoteChildCodes) throws WorkflowException
+    protected boolean synchronizeMetadata (Node contentNode, Document doc, SynchronizableContent content, Node metadataNode, SynchronizationReport report, Logger logger, boolean importMode, String programLanguage, Set<String> remoteChildCodes) throws WorkflowException
     {
         boolean hasChanges = false;
         
@@ -466,17 +468,18 @@
         
         if (isMultiple)
         {
-            hasChanges = synchronizeMultipleMetadata (doc, content, type, metadataName, metadataNode, report, logger, importMode, programLanguage) || hasChanges;
+            hasChanges = synchronizeMultipleMetadata (contentNode, doc, content, type, metadataName, metadataNode, report, logger, importMode, programLanguage) || hasChanges;
         }
         else
         {
-            hasChanges = synchronizeSingleMetadata(doc, content, type, metadataName, metadataNode, importMode, programLanguage, remoteChildCodes, report, logger) || hasChanges;
+            hasChanges = synchronizeSingleMetadata(contentNode, doc, content, type, metadataName, metadataNode, importMode, programLanguage, remoteChildCodes, report, logger) || hasChanges;
         }
         return hasChanges;
     }
 
     /**
      * Import a multiple field 
+     * @param contentNode the content node
      * @param doc The root document
      * @param content The content to synchronize
      * @param type The metadata type
@@ -489,14 +492,14 @@
      * @return <code>true</code> if changes were made
      * @throws WorkflowException
      */
-    protected boolean synchronizeMultipleMetadata (Document doc, SynchronizableContent content, String type, String metadataName, Node metadataNode, SynchronizationReport report, Logger logger, boolean importMode, String programLanguage) throws WorkflowException
+    protected boolean synchronizeMultipleMetadata (Node contentNode, Document doc, SynchronizableContent content, String type, String metadataName, Node metadataNode, SynchronizationReport report, Logger logger, boolean importMode, String programLanguage) throws WorkflowException
     {
         boolean hasChanges = false;
         
         if (type.equals(CDMFRConstant.IMPORT_TYPE_STRING))
         {
             // Keywords, siseCode, ...
-            hasChanges = CDMSynchronizationHelper.synchronizeStringArrayMetadata(metadataNode, content, metadataName, _enumerationHelper, importMode);
+            hasChanges = CDMSynchronizationHelper.synchronizeStringArrayMetadata(contentNode, metadataNode, content, metadataName, _enumerationHelper, _xPathProcessor, importMode);
         }
         else if (type.equals("person"))
         {
@@ -655,6 +658,7 @@
     
     /**
      * Import a single field (metadata or sub-node)
+     * @param contentNode the content node
      * @param doc The root document
      * @param content The synchronized content
      * @param type The metadata type
@@ -668,11 +672,11 @@
      * @return <code>true</code> if changes were made
      * @throws WorkflowException
      */
-    protected boolean synchronizeSingleMetadata(Document doc, SynchronizableContent content, String type, String name, Node metadataNode, boolean importMode, String programLanguage, Set<String> remoteChildCodes, SynchronizationReport report, Logger logger) throws WorkflowException
+    protected boolean synchronizeSingleMetadata(Node contentNode, Document doc, SynchronizableContent content, String type, String name, Node metadataNode, boolean importMode, String programLanguage, Set<String> remoteChildCodes, SynchronizationReport report, Logger logger) throws WorkflowException
     {
         if (type.equals(CDMFRConstant.IMPORT_TYPE_STRING))
         {
-            return CDMSynchronizationHelper.synchronizeStringMetadata (metadataNode, content, name, _enumerationHelper, importMode);
+            return CDMSynchronizationHelper.synchronizeStringMetadata (contentNode, metadataNode, content, name, _enumerationHelper, _xPathProcessor, importMode);
         }
         else if (type.equals(CDMFRConstant.IMPORT_TYPE_DATE))
         {
@@ -692,7 +696,7 @@
         }
         else if (type.equals(CDMFRConstant.IMPORT_TYPE_FILE))
         {
-            return CDMSynchronizationHelper.synchronizeFileMetadata (metadataNode, content, name, _context, importMode);
+            return CDMSynchronizationHelper.synchronizeFileMetadata (contentNode, metadataNode, content, name, _context, importMode);
         }
         else if (type.equals(CDMFRConstant.IMPORT_TYPE_GEOCODE))
         {
@@ -700,7 +704,7 @@
         }
         else if (type.equals(CDMFRConstant.IMPORT_TYPE_REPEATER))
         {
-            return synchronizeRepeaterMetadata (doc, metadataNode, content, name, report, logger, importMode);
+            return synchronizeRepeaterMetadata (contentNode, doc, metadataNode, content, name, report, logger, importMode);
         }
         else if (type.equals(CDMFRConstant.IMPORT_TYPE_COURSE_LIST))
         {
@@ -800,6 +804,7 @@
     
     /**
      * Synchronize a repeater metadata
+     * @param contentNode the content node
      * @param doc The root document
      * @param metadataNode The metadata DOM node
      * @param content The content to synchronize
@@ -810,7 +815,7 @@
      * @return <code>true</code> if changes were made
      * @throws WorkflowException 
      */
-    public boolean synchronizeRepeaterMetadata (Document doc, Node metadataNode, SynchronizableContent content, String metadataName, SynchronizationReport report, Logger logger, boolean importMode) throws WorkflowException
+    public boolean synchronizeRepeaterMetadata (Node contentNode, Document doc, Node metadataNode, SynchronizableContent content, String metadataName, SynchronizationReport report, Logger logger, boolean importMode) throws WorkflowException
     {
         if (metadataName.equals("lomSheets"))
         {
@@ -818,7 +823,7 @@
         }
         else
         {
-            return CDMSynchronizationHelper.synchronizeRepeaterMetadata(metadataNode, content, metadataName, _enumerationHelper, _xPathProcessor, _context);
+            return CDMSynchronizationHelper.synchronizeRepeaterMetadata(contentNode, metadataNode, content, metadataName, _enumerationHelper, _xPathProcessor, _context);
         }
     }
 
@@ -1165,20 +1170,30 @@
      */
     protected SynchronizableContent getOrCreateSubProgram (Node spNode, TraversableAmetysObject parentContent, String lang, SynchronizationReport report, Logger logger)
     {
-        String contentTitle = _xPathProcessor.evaluateAsString(spNode, "title");
-        String contentName = _xPathProcessor.evaluateAsString(spNode, "cdmCode");
-        
-        AmetysObjectIterable<AmetysObject> children = parentContent.getChildren();
-        for (AmetysObject ao : children)
+        SynchronizableContent subProgram = _getSubProgram(spNode, parentContent, report, logger);
+        if (subProgram != null)
         {
-            if (ao instanceof SubProgram)
-            {
-                if (_xPathProcessor.evaluateAsString(spNode, "code").equals(((SubProgram) ao).getCode()))
-                {
-                    return (SynchronizableContent) ao;
-                }
-            }
+            return subProgram;
         }
+        else
+        {
+            return _createSubProgram(spNode, parentContent, lang, report, logger);
+        }
+    }
+    
+    /**
+     * Create a sub-program 
+     * @param spNode the DOM for sub-program
+     * @param parentContent the parent content
+     * @param lang The content language
+     * @param report the report for logs
+     * @param logger The logger
+     * @return the sub-program (return null if no exist)
+     */
+    protected SynchronizableContent _createSubProgram (Node spNode, TraversableAmetysObject parentContent, String lang, SynchronizationReport report, Logger logger)
+    {
+        String contentTitle = _xPathProcessor.evaluateAsString(spNode, "title");
+        String contentName = _xPathProcessor.evaluateAsString(spNode, "cdmCode");
         
         try
         {
@@ -1199,6 +1214,32 @@
     }
     
     /**
+    * Get a sub-program 
+    * @param spNode the DOM for sub-program
+    * @param parentContent the parent content
+    * @param report the report for logs
+    * @param logger The logger
+    * @return the sub-program (return null if no exist)
+    */
+    
+    protected SynchronizableContent _getSubProgram (Node spNode, TraversableAmetysObject parentContent, SynchronizationReport report, Logger logger)
+    {
+        AmetysObjectIterable<AmetysObject> children = parentContent.getChildren();
+        for (AmetysObject ao : children)
+        {
+            if (ao instanceof SubProgram)
+            {
+                if (_xPathProcessor.evaluateAsString(spNode, "code").equals(((SubProgram) ao).getCode()))
+                {
+                    return (SynchronizableContent) ao;
+                }
+            }
+        }
+        
+        return null;
+    }
+    
+    /**
      * Get a container or create it if not exists
      * @param cNode the DOM for container
      * @param parentContent the parent content
Index: main/plugin-odf-sync/src/org/ametys/plugins/odfsync/cdmfr/CDMFrImportManager.java
===================================================================
--- main/plugin-odf-sync/src/org/ametys/plugins/odfsync/cdmfr/CDMFrImportManager.java	(revision 41919)
+++ main/plugin-odf-sync/src/org/ametys/plugins/odfsync/cdmfr/CDMFrImportManager.java	(working copy)
@@ -108,8 +108,6 @@
      */
     protected List<Program> importPrograms(InputStream stream, SynchronizationReport report, Logger logger) throws WorkflowException, AmetysRepositoryException
     {
-        String defaultCatalog = getDefaultCatalog();
-        
         List<Program> importedPrograms = new ArrayList<Program>();
         try
         {
@@ -145,44 +143,7 @@
                     {
                         try
                         {
-                            // Create program
-                            String contentTitle = _xPathProcessor.evaluateAsString(contentNode, "title");
-                            
-                            String infoMsg = "Création de la formation " + contentName;
-                            report.info(infoMsg);
-                            logger.info(infoMsg);
-                            
-                            String contentId = createContent(ProgramFactory.PROGRAM_CONTENT_TYPE, contentLang, contentName, contentTitle, _programWorkflowName, 1, null);
-                            content = _resolver.resolveById(contentId);
-                            synchronizeContent(doc, content, contentNode, report, logger, true, contentLang);
-                            
-                            String catalog = ((Program) content).getCatalog();
-                            if (StringUtils.isEmpty(catalog) && defaultCatalog != null)
-                            {
-                                // Set the default catalog
-                                ((Program) content).setCatalog(defaultCatalog);
-                            }
-                            else if (StringUtils.isNotEmpty(catalog))
-                            {
-                                if (_catalogsManager.getCatalog(catalog) == null)
-                                {
-                                    // Catalog does not exits ...
-                                    if (defaultCatalog != null)
-                                    {
-                                        // ... and there is a default catalog, set the default catalog
-                                        ((Program) content).setCatalog(defaultCatalog);
-                                    }
-                                    else
-                                    {
-                                        // ... and there is no default catalog, remove it
-                                        content.getMetadataHolder().removeMetadata(Program.CATALOG);
-                                    }
-                                }
-                            }
-                                
-                            content.saveChanges();
-                            content.checkpoint();
-                            
+                            content = createProgram(contentNode, doc, contentName, contentLang, report, logger);
                             importedPrograms.add((Program) content);
                         }
                         catch (WorkflowException e) 
@@ -227,6 +188,71 @@
         return importedPrograms;
     }
     
+    /**
+     * Create the program content
+     * @param contentNode the content node
+     * @param doc the document
+     * @param contentName the content name
+     * @param contentLang the content lang
+     * @param report the logger report
+     * @param logger the logger
+     * @return the created program
+     * @throws WorkflowException if an error occurred
+     */
+    protected SynchronizableContent createProgram(Node contentNode, Document doc, String contentName, String contentLang, SynchronizationReport report, Logger logger) throws WorkflowException
+    {
+        // Create program
+        String contentTitle = _xPathProcessor.evaluateAsString(contentNode, "title");
+        
+        String infoMsg = "Création de la formation " + contentName;
+        report.info(infoMsg);
+        logger.info(infoMsg);
+        
+        String contentId = createContent(ProgramFactory.PROGRAM_CONTENT_TYPE, contentLang, contentName, contentTitle, _programWorkflowName, 1, null);
+        SynchronizableContent content = _resolver.resolveById(contentId);
+        synchronizeContent(doc, content, contentNode, report, logger, true, contentLang);
+        
+        setProgramCatalog(content);
+            
+        content.saveChanges();
+        content.checkpoint();
+        
+        return content;
+    }
+    
+    /**
+     * Set the catalog to the program
+     * @param content the program
+     */
+    protected void setProgramCatalog(SynchronizableContent content)
+    {
+        String defaultCatalog = getDefaultCatalog();
+        
+        String catalog = ((Program) content).getCatalog();
+        if (StringUtils.isEmpty(catalog) && defaultCatalog != null)
+        {
+            // Set the default catalog
+            ((Program) content).setCatalog(defaultCatalog);
+        }
+        else if (StringUtils.isNotEmpty(catalog))
+        {
+            if (_catalogsManager.getCatalog(catalog) == null)
+            {
+                // Catalog does not exits ...
+                if (defaultCatalog != null)
+                {
+                    // ... and there is a default catalog, set the default catalog
+                    ((Program) content).setCatalog(defaultCatalog);
+                }
+                else
+                {
+                    // ... and there is no default catalog, remove it
+                    content.getMetadataHolder().removeMetadata(Program.CATALOG);
+                }
+            }
+        }
+    }
+    
     @Override
     public List< ? extends SearchRemoteItem> searchRemotePrograms(Map<String, String> params)
     {
Index: main/plugin-odf-sync/src/org/ametys/plugins/odfsync/cdmfr/CDMSynchronizationHelper.java
===================================================================
--- main/plugin-odf-sync/src/org/ametys/plugins/odfsync/cdmfr/CDMSynchronizationHelper.java	(revision 41919)
+++ main/plugin-odf-sync/src/org/ametys/plugins/odfsync/cdmfr/CDMSynchronizationHelper.java	(working copy)
@@ -49,33 +49,32 @@
 import org.w3c.dom.NodeList;
 
 import org.ametys.odf.SynchronizableContent;
+import org.ametys.odf.enumeration.OdfEnumerationConstant;
 import org.ametys.odf.enumeration.OdfEnumerationHelper;
+import org.ametys.odf.program.Program;
 import org.ametys.plugins.repository.metadata.ModifiableBinaryMetadata;
 import org.ametys.plugins.repository.metadata.ModifiableCompositeMetadata;
 import org.ametys.plugins.repository.metadata.ModifiableFile;
 import org.ametys.plugins.repository.metadata.ModifiableResource;
 import org.ametys.plugins.repository.metadata.ModifiableRichText;
 import org.ametys.plugins.repository.metadata.UnknownMetadataException;
+import org.ametys.runtime.config.Config;
 import org.ametys.runtime.util.LoggerFactory;
 
 /**
  * Helper for CDM-fr synchronization or import
  *
  */
-public final class CDMSynchronizationHelper
+public class CDMSynchronizationHelper
 {
     private static final Pattern __URL_REGEXP = Pattern.compile("^(https?:\\/\\/.+)$");
     private static SimpleDateFormat _dateFormat = new SimpleDateFormat("yyyy-MM-dd");
     
     private static Logger _logger = LoggerFactory.getLoggerFor(CDMSynchronizationHelper.class);
     
-    private CDMSynchronizationHelper ()
-    {
-        // Nothing
-    }
-    
     /**
      * Synchronize a repeater metadata
+     * @param contentNode the content node
      * @param metadataNode The metadata DOM node
      * @param content The synchronized content
      * @param metadataName The metadata name
@@ -84,7 +83,7 @@
      * @param cocoonContext The cocoon context
      * @return <code>true</code> if changes were made
      */
-    public static boolean synchronizeRepeaterMetadata (Node metadataNode, SynchronizableContent content, String metadataName, OdfEnumerationHelper enumerationHelper, XPathProcessor xpathProcessor, Context cocoonContext)
+    public static boolean synchronizeRepeaterMetadata (Node contentNode, Node metadataNode, SynchronizableContent content, String metadataName, OdfEnumerationHelper enumerationHelper, XPathProcessor xpathProcessor, Context cocoonContext)
     {
         boolean hasChanges = false;
         
@@ -118,7 +117,7 @@
                 boolean isMultiple = multipleItem != null && "true".equals(multipleItem.getTextContent().trim());
                 
                 // Metadata of repeater can not be synchronizable for now
-                hasChanges = synchronizeNoSynchronizableMetadata(content, entry, type, subMetadataName, childNode, enumerationHelper, xpathProcessor, cocoonContext, isMultiple)  || hasChanges;
+                hasChanges = synchronizeNoSynchronizableMetadata(contentNode, content, entry, type, subMetadataName, childNode, enumerationHelper, xpathProcessor, cocoonContext, isMultiple)  || hasChanges;
             }
         }
         
@@ -128,6 +127,7 @@
     
     /**
      * Synchronize a no-synchronizable metadata
+     * @param contentNode the content node
      * @param content The synchronized content
      * @param compositeMetadata The composite metadata
      * @param type The type
@@ -139,17 +139,17 @@
      * @param multiple <code>true</code> if metadata is multiple
      * @return <code>true</code> if changes were made
      */
-    public static boolean synchronizeNoSynchronizableMetadata (SynchronizableContent content, ModifiableCompositeMetadata compositeMetadata, String type, String metadataName, Node metadataNode, OdfEnumerationHelper enumerationHelper, XPathProcessor xpathProcessor, Context cocoonContext, boolean multiple)
+    public static boolean synchronizeNoSynchronizableMetadata (Node contentNode, SynchronizableContent content, ModifiableCompositeMetadata compositeMetadata, String type, String metadataName, Node metadataNode, OdfEnumerationHelper enumerationHelper, XPathProcessor xpathProcessor, Context cocoonContext, boolean multiple)
     {
         if (type.equals(CDMFRConstant.IMPORT_TYPE_STRING))
         {
             if (multiple)
             {
-                return synchronizeNoSynchronizableStringArrayMetadata(metadataNode, compositeMetadata, metadataName, enumerationHelper);
+                return synchronizeNoSynchronizableStringArrayMetadata(contentNode, metadataNode, compositeMetadata, metadataName, enumerationHelper, xpathProcessor);
             }
             else
             {
-                return synchronizeNoSynchronizableStringMetadata (metadataNode, compositeMetadata, metadataName, enumerationHelper);
+                return synchronizeNoSynchronizableStringMetadata (contentNode, metadataNode, compositeMetadata, metadataName, enumerationHelper, xpathProcessor);
             }
         }
         else if (type.equals(CDMFRConstant.IMPORT_TYPE_DATE))
@@ -166,7 +166,7 @@
         }
         else if (type.equals(CDMFRConstant.IMPORT_TYPE_FILE))
         {
-            return synchronizeNoSynchronizableFileMetadata(metadataNode, compositeMetadata, metadataName, cocoonContext);
+            return synchronizeNoSynchronizableFileMetadata(contentNode, metadataNode, compositeMetadata, metadataName, cocoonContext);
         }
         else if (type.equals(CDMFRConstant.IMPORT_TYPE_RICH_TEXT))
         {
@@ -186,18 +186,20 @@
     
     /**
      * Synchronize a String metadata
+     * @param contentNode the content node
      * @param metadataNode The metadata DOM node
      * @param content The content 
      * @param metadataName The metadata name
      * @param enumerationHelper the {@link OdfEnumerationHelper}.
+     * @param xpathProcessor the xpath processor
      * @param importMode <code>true</code> if it is import mode
      * @return <code>true</code> if changes were made
      */
-    public static boolean synchronizeStringMetadata(Node metadataNode, SynchronizableContent content, String metadataName, OdfEnumerationHelper enumerationHelper, boolean importMode)
+    public static boolean synchronizeStringMetadata(Node contentNode, Node metadataNode, SynchronizableContent content, String metadataName, OdfEnumerationHelper enumerationHelper, XPathProcessor xpathProcessor, boolean importMode)
     {
         boolean isSynchonizable = isSynchronizable(metadataNode);
         
-        String constant = getConstant(metadataNode);
+        String constant = getConstant(contentNode, metadataNode, enumerationHelper, xpathProcessor);
         String value = metadataNode.getTextContent().trim();
         if (constant != null)
         {
@@ -231,15 +233,17 @@
     
     /**
      * Synchronize a no-synchronizable String metadata. This method is used for metadata in a repeater for example
+     * @param contentNode the content node
      * @param metadataNode The metadata DOM node
      * @param compositeMetadata The composite metadata
      * @param metadataName The metadata name
      * @param enumerationHelper the {@link OdfEnumerationHelper}.
+     * @param xpathProcessor the xpath processor
      * @return <code>true</code> if changes were made
      */
-    public static boolean synchronizeNoSynchronizableStringMetadata(Node metadataNode, ModifiableCompositeMetadata compositeMetadata, String metadataName, OdfEnumerationHelper enumerationHelper)
+    public static boolean synchronizeNoSynchronizableStringMetadata(Node contentNode, Node metadataNode, ModifiableCompositeMetadata compositeMetadata, String metadataName, OdfEnumerationHelper enumerationHelper, XPathProcessor xpathProcessor)
     {
-        String constant = getConstant(metadataNode);
+        String constant = getConstant(contentNode, metadataNode, enumerationHelper, xpathProcessor);
         String value = metadataNode.getTextContent().trim();
         if (constant != null)
         {
@@ -258,18 +262,20 @@
     
     /**
      * Synchronize a String metadata
+     * @param contentNode the content node
      * @param metadataNode The metadata DOM node
      * @param content The content 
      * @param metadataName The metadata name
      * @param enumerationHelper The enumeration helper
+     * @param xpathProcessor the xpath processor
      * @param importMode <code>true</code> if it is import mode
      * @return <code>true</code> if changes were made
      */
-    public static boolean synchronizeStringArrayMetadata(Node metadataNode, SynchronizableContent content, String metadataName, OdfEnumerationHelper enumerationHelper, boolean importMode)
+    public static boolean synchronizeStringArrayMetadata(Node contentNode, Node metadataNode, SynchronizableContent content, String metadataName, OdfEnumerationHelper enumerationHelper, XPathProcessor xpathProcessor, boolean importMode)
     {
         boolean isSynchonizable = isSynchronizable(metadataNode);
         
-        String constant = getConstant(metadataNode);
+        String constant = getConstant(contentNode, metadataNode, enumerationHelper, xpathProcessor);
         
         NodeList itemNodes = metadataNode.getChildNodes();
         List<String> values = new ArrayList<String>();
@@ -313,15 +319,17 @@
     
     /**
      * Synchronize a String metadata
+     * @param contentNode the content node
      * @param metadataNode The metadata DOM node
      * @param compositeMetadata The composite metadata 
      * @param metadataName The metadata name
      * @param enumerationHelper The enumeration helper
+     * @param xpathProcessor the xpath processor
      * @return <code>true</code> if changes were made
      */
-    public static boolean synchronizeNoSynchronizableStringArrayMetadata(Node metadataNode, ModifiableCompositeMetadata compositeMetadata, String metadataName, OdfEnumerationHelper enumerationHelper)
+    public static boolean synchronizeNoSynchronizableStringArrayMetadata(Node contentNode, Node metadataNode, ModifiableCompositeMetadata compositeMetadata, String metadataName, OdfEnumerationHelper enumerationHelper, XPathProcessor xpathProcessor)
     {
-        String constant = getConstant(metadataNode);
+        String constant = getConstant(contentNode, metadataNode, enumerationHelper, xpathProcessor);
         
         NodeList itemNodes = metadataNode.getChildNodes();
         List<String> values = new ArrayList<String>();
@@ -349,6 +357,7 @@
     
     /**
      * Synchronize a File metadata
+     * @param contentNode the content node
      * @param metadataNode The metadata DOM node
      * @param content The content 
      * @param metadataName The metadata name
@@ -356,7 +365,7 @@
      * @param importMode <code>true</code> if it is import mode
      * @return <code>true</code> if changes were made
      */
-    public static boolean synchronizeFileMetadata(Node metadataNode, SynchronizableContent content, String metadataName, Context cocoonContext, boolean importMode)
+    public static boolean synchronizeFileMetadata(Node contentNode, Node metadataNode, SynchronizableContent content, String metadataName, Context cocoonContext, boolean importMode)
     {
         String value = metadataNode.getTextContent().trim();
         boolean isSynchronizable = isSynchronizable(metadataNode);
@@ -411,7 +420,7 @@
                 }
             }
             
-            return synchronizeStringArrayMetadata(metadataNode, content, metadataName, null, importMode);
+            return synchronizeStringArrayMetadata(contentNode, metadataNode, content, metadataName, null, null, importMode);
         }
     }
     
@@ -495,13 +504,14 @@
     
     /**
      * Synchronize a no-synchronizable Binary metadata. This method is used for metadata in a repeater for example
+     * @param contentNode the content node
      * @param metadataNode The metadata DOM node
      * @param compositeMetadata The composite metadata
      * @param metadataName The metadata name
      * @param cocoonContext The cocoon context
      * @return <code>true</code> if changes were made
      */
-    public static boolean synchronizeNoSynchronizableFileMetadata(Node metadataNode, ModifiableCompositeMetadata compositeMetadata, String metadataName, Context cocoonContext)
+    public static boolean synchronizeNoSynchronizableFileMetadata(Node contentNode, Node metadataNode, ModifiableCompositeMetadata compositeMetadata, String metadataName, Context cocoonContext)
     {
         String value = metadataNode.getTextContent().trim();
         
@@ -533,7 +543,7 @@
                 // Do nothing
             }
             
-            return synchronizeNoSynchronizableStringMetadata(metadataNode, compositeMetadata, metadataName, null);
+            return synchronizeNoSynchronizableStringMetadata(contentNode, metadataNode, compositeMetadata, metadataName, null, null);
         }
     }
     
@@ -1067,15 +1077,43 @@
     
     /**
      * Determines if field is a constant
-     * @param node the DOM
+     * @param contentNode the content node
+     * @param metadataNode the metadata node
+     * @param enumerationHelper The enumeration helper
+     * @param xpathProcessor The xpath processor
      * @return true if the field is synchronizable
      */
-    public static String getConstant (Node node)
+    public static String getConstant (Node contentNode, Node metadataNode, OdfEnumerationHelper enumerationHelper, XPathProcessor xpathProcessor)
     {
-        Node constant = node.getAttributes().getNamedItem("constant");
+        Node constant = metadataNode.getAttributes().getNamedItem("constant");
         if (constant != null)
         {
-            return constant.getTextContent().trim();
+            String constantAsString = constant.getTextContent().trim();
+            if (constantAsString.equals("MENTION"))
+            {
+                String degree = xpathProcessor.evaluateAsString(contentNode, Program.DEGREE); 
+                String degreeCode = enumerationHelper.getItemCode(OdfEnumerationConstant.DEGREE, degree);
+                
+                String mentionKey = null;
+                if (degreeCode.equals(Config.getInstance().getValueAsString("odf.programs.degree.license")))
+                {
+                    mentionKey = OdfEnumerationConstant.MENTION_LICENCE;
+                }
+                else if (degreeCode.equals(Config.getInstance().getValueAsString("odf.programs.degree.master")))
+                {
+                    mentionKey = OdfEnumerationConstant.MENTION_MASTER;
+                }
+                else if (degreeCode.equals(Config.getInstance().getValueAsString("odf.programs.degree.licensepro")))
+                {
+                    mentionKey = OdfEnumerationConstant.MENTION_LICENCEPRO;
+                }
+                
+                return mentionKey;
+            }
+            else
+            {
+                return constantAsString;
+            }
         }
         return null;
     }
